// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_video_monitor_interfaces:srv/StopRecording.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__STOP_RECORDING__TRAITS_HPP_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__STOP_RECORDING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gazebo_video_monitor_interfaces/srv/detail/stop_recording__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StopRecording_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: discard
  {
    out << "discard: ";
    rosidl_generator_traits::value_to_yaml(msg.discard, out);
    out << ", ";
  }

  // member: filename
  {
    out << "filename: ";
    rosidl_generator_traits::value_to_yaml(msg.filename, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StopRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: discard
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "discard: ";
    rosidl_generator_traits::value_to_yaml(msg.discard, out);
    out << "\n";
  }

  // member: filename
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "filename: ";
    rosidl_generator_traits::value_to_yaml(msg.filename, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StopRecording_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::StopRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::StopRecording_Request & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StopRecording_Request>()
{
  return "gazebo_video_monitor_interfaces::srv::StopRecording_Request";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StopRecording_Request>()
{
  return "gazebo_video_monitor_interfaces/srv/StopRecording_Request";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StopRecording_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::StopRecording_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StopRecording_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: path
  {
    out << "path: ";
    rosidl_generator_traits::value_to_yaml(msg.path, out);
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StopRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path: ";
    rosidl_generator_traits::value_to_yaml(msg.path, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StopRecording_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::StopRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::StopRecording_Response & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StopRecording_Response>()
{
  return "gazebo_video_monitor_interfaces::srv::StopRecording_Response";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StopRecording_Response>()
{
  return "gazebo_video_monitor_interfaces/srv/StopRecording_Response";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StopRecording_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::StopRecording_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StopRecording_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StopRecording_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StopRecording_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::StopRecording_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::StopRecording_Event & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StopRecording_Event>()
{
  return "gazebo_video_monitor_interfaces::srv::StopRecording_Event";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StopRecording_Event>()
{
  return "gazebo_video_monitor_interfaces/srv/StopRecording_Event";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StopRecording_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Event>
  : std::integral_constant<bool, has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Request>::value && has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::StopRecording_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StopRecording>()
{
  return "gazebo_video_monitor_interfaces::srv::StopRecording";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StopRecording>()
{
  return "gazebo_video_monitor_interfaces/srv/StopRecording";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StopRecording>
  : std::integral_constant<
    bool,
    has_fixed_size<gazebo_video_monitor_interfaces::srv::StopRecording_Request>::value &&
    has_fixed_size<gazebo_video_monitor_interfaces::srv::StopRecording_Response>::value
  >
{
};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording>
  : std::integral_constant<
    bool,
    has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Request>::value &&
    has_bounded_size<gazebo_video_monitor_interfaces::srv::StopRecording_Response>::value
  >
{
};

template<>
struct is_service<gazebo_video_monitor_interfaces::srv::StopRecording>
  : std::true_type
{
};

template<>
struct is_service_request<gazebo_video_monitor_interfaces::srv::StopRecording_Request>
  : std::true_type
{
};

template<>
struct is_service_response<gazebo_video_monitor_interfaces::srv::StopRecording_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__STOP_RECORDING__TRAITS_HPP_
